#pragma once
#include "afxwin.h"

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

#import "VaxServerWebRTC.dll" rename_namespace("VaxServerWebRTC")

using namespace VaxServerWebRTC;

class CVaxServerWebRTC : public CCmdTarget
{
	DECLARE_DYNCREATE(CVaxServerWebRTC)

public:
	CVaxServerWebRTC();
	~CVaxServerWebRTC();

public:

	DWORD m_dwCookie;
	
	_IServerWebRTCEvents* m_pVaxEvents;
	IServerWebRTC* m_pVaxSIP;

	//------------------------------------------------------------------------------------------------------------------
	//-------------------------------			Functions Added
	//------------------------------------------------------------------------------------------------------------------
	
	BOOL LoadObjectCOM();
	void UnLoadObjectCOM();
	BOOL IsLoadedObjectCOM();

public:

	CString GetVersionFile();
	CString GetVersionSDK();
	BOOL SetLicenceKey(LPCTSTR LicenceKey);

	int GetVaxErrorCode();
	CString GetVaxErrorMsg();
	
	BOOL Initialize(LPCTSTR sListenIP, int nListenPort, LPCTSTR sCertKeySSL, LPCTSTR sCertCrtSSL, LPCTSTR sPathURL);
	void UnInitialize();

	int GetClientCount();

	BOOL GetStartListenIP();
	CString GetNextListenIP();

	CString BuildWebSocketURL();
	BOOL SetListenPortRangeRTP(int nPortMinWebRTC, int nPortMaxWebRTC, int nPortMinSIP, int nPortMaxSIP);
	
public:

	afx_msg virtual void OnFinalRelease();


///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

public:
		
	virtual void OnVaxErrorLog(LPCTSTR sFuncName, LPCTSTR sErrorMsg, int nErrorCode);
	
	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CVaxServerWebRTC)
						
	//}}AFX_DISPATCH

	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

};

