﻿// Class cVaxPhone

var m_objVaxPhoneTransfer;
var m_objVaxPhoneTone;
var m_objVaxPhoneIncomingCall;
var m_objVaxPhoneOutgoingCall;

function cVaxPhone() 
{
	m_objVaxPhoneIncomingCall = new cVaxPhoneIncomingCall();
    m_objVaxPhoneOutgoingCall = new cVaxPhoneOutgoingCall();
    m_objVaxPhoneTransfer = new cVaxPhoneTransfer();
    m_objVaxPhoneTone = new cVaxPhoneTone();
  	 
 	this.OnLoadPage = function ()
	{
		m_objVaxPhoneOutgoingCall.OnLoadPage();
	}
 
    this.OnVaxInit = function () 
    {	
		m_objVaxPhoneIncomingCall.OnVaxInit();
        m_objVaxPhoneOutgoingCall.OnVaxInit();	
	
        m_objVaxPhoneTransfer.OnVaxInit();
				
        m_objVaxPhoneTone.OnVaxInit();
        CheckForwardCall.checked = false;
    }

    this.OnVaxUnInit = function () 
    {
		m_objVaxPhoneIncomingCall.OnVaxUnInit();
        m_objVaxPhoneOutgoingCall.OnVaxUnInit();
		
        m_objVaxPhoneTransfer.OnVaxUnInit();
        m_objVaxPhoneTone.OnVaxUnInit();
		
        ListPhoneLog.value = "";
    }

    this.CheckForwardCall_onclick = function () 
    {	
		if (EditForwardCallPhoneNo.value == "") 
        {
            CheckForwardCall.checked = false;
            ShowDialog("Please enter a phone number.");
            return;
        }

        m_objVaxFuncSIP.ForwardCall(CheckForwardCall.checked, EditForwardCallPhoneNo.value); 
    }

    this.AddToPhoneLogList = function(value)
    {	
        if (ListPhoneLog.value.length == 0)
            ListPhoneLog.value = ListPhoneLog.value + value;
        else
            ListPhoneLog.value = ListPhoneLog.value + "\n" + value;

        ListPhoneLog.scrollTop = ListPhoneLog.scrollHeight;
    }

    this.BtnClearPhoneLog_onclick = function () 
    {
        ListPhoneLog.value = "";
    }
        
    ///////////////////////////////////////////////////////////////////////////

    this.OnWebConnectionTrying = function ()
    {
        this.AddToPhoneLogList("Connecting to Server WebRTC.");
    }

    this.OnWebConnectionSuccess = function ()
    {
        this.AddToPhoneLogList("Connected to Server WebRTC.");
    }

    this.OnWebConnectionFailed = function (sMsg)
    {
        this.AddToPhoneLogList(sMsg);
    }

    this.OnWebConnectionClosed = function ()
    {
        this.AddToPhoneLogList("Connection closed to Server WebRTC.");
    }

    ///////////////////////////////////////////////////////////////////////////

    this.OnDigitDTMF = function (Digit) 
    {
        this.AddToPhoneLogList("Key-pressed: " + Digit);
    }
};