﻿
// Class cVaxSetting

const VAX_DIGIT_DTMF_RFC2833 = 0;
const VAX_DIGIT_DTMF_SIP_INFO = 1;
const VAX_DIGIT_DTMF_INBAND = 2;

function cVaxSetting() 
{
    RadioVCNormal.checked = true;
    RadioForceNone.checked = true;

    this.OnVaxInit = function () 
    {	
		ActivateOtherSettings();
        ActivateVoiceChanger();

        ActivateDigitDTMF();
    }

    this.OnVaxUnInit = function()
    {
    
    }

////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

    this.CheckDisturb_onclick = function () 
    {
        ActivateOtherSettings();
    }

////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

    this.RadioVCNormal_onclick = function () 
    {
        ActivateVoiceChanger();
    }

    this.RadioVCGrandpa_onclick = function () 
    {
        ActivateVoiceChanger();
    }

    this.RadioVCTeen_onclick = function () 
    {
        ActivateVoiceChanger();
    }

    this.RadioVCHouseHold_onclick = function () 
    {
        ActivateVoiceChanger();
    }

    this.RadioVCHelium_onclick = function () 
    {
        ActivateVoiceChanger();
    }

    this.RadioVCChipmunk_onclick = function () 
    {
        ActivateVoiceChanger();
    }

    ////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////

    this.RadioForceNone_Click = function () 
    {
        ActivateDigitDTMF();
    }

    this.RadioForceInbandDTMF_Click = function () 
    {
        ActivateDigitDTMF();
    }

    this.RadioForceRfc2833DTMF_Click = function () 
    {
        ActivateDigitDTMF();
    }

    this.RadioForceInfoDTMF_Click = function () 
    {
        ActivateDigitDTMF();
    }


    //////////////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////////////

    function ActivateOtherSettings() 
    {
		m_objVaxFuncSIP.DonotDisturb(CheckDisturb.checked);
    }

    //////////////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////////////

    function ActivateVoiceChanger() 
    {
		if (RadioVCNormal.checked) 
            m_objVaxFuncSIP.VoiceChanger(-1);

        else if (RadioVCGrandpa.checked)
            m_objVaxFuncSIP.VoiceChanger(4);

        else if (RadioVCTeen.checked)
            m_objVaxFuncSIP.VoiceChanger(8);

        else if (RadioVCHouseHold.checked)
            m_objVaxFuncSIP.VoiceChanger(12);

        else if (RadioVCHelium.checked)
            m_objVaxFuncSIP.VoiceChanger(16);

        else if (RadioVCChipmunk.checked)
            m_objVaxFuncSIP.VoiceChanger(20);		
    }

    ////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////

    function ActivateDigitDTMF() 
    {
        if (RadioForceNone.checked) 
        {          
      		m_objVaxFuncSIP.ForceDigitDTMF(VAX_DIGIT_DTMF_RFC2833, true);
        }

        else if (RadioForceInbandDTMF.checked)
        {
           m_objVaxFuncSIP.ForceDigitDTMF(VAX_DIGIT_DTMF_INBAND, RadioForceInbandDTMF.checked);
        }

        else if (RadioForceRfc2833DTMF.checked)
        {
           m_objVaxFuncSIP.ForceDigitDTMF(VAX_DIGIT_DTMF_RFC2833, RadioForceRfc2833DTMF.checked); 
        }

        else if (RadioForceInfoDTMF.checked)
        {
           m_objVaxFuncSIP.ForceDigitDTMF(VAX_DIGIT_DTMF_SIP_INFO, RadioForceInfoDTMF.checked);
        }
    }

};