
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

var m_sAcceptedCallId = '';

function cVaxPhoneEventSIP() 
{
    this.OnWebConnectionTrying = function()
    {
        m_objVaxAccount.OnWebConnectionTrying();
        m_objVaxPhone.OnWebConnectionTrying();
    }

    this.OnWebConnectionSuccess = function () 
    {
        m_objVaxAccount.OnWebConnectionSuccess();
        m_objVaxPhone.OnWebConnectionSuccess();
    }

    this.OnWebConnectionFailed = function(sMsg)
    {
        m_objVaxAccount.OnWebConnectionFailed(sMsg);
        m_objVaxPhone.OnWebConnectionFailed(sMsg);
    }

    this.OnWebConnectionClosed = function()
    {
        m_objVaxAccount.OnWebConnectionClosed();
        m_objVaxPhone.OnWebConnectionClosed();
    }

    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    this.OnPhoneEventSIP = function (sMsg) 
    {
        var jsonParse = JSON.parse(sMsg);

        var sEventName = jsonParse.EventName;
        var aEventParam = jsonParse.EventParam;

        if (sEventName == "OnInitialized") 
        {
            this.OnInitialized();
        }

        else if (sEventName == "OnUnInitialized") 
        {
            this.OnUnInitialized();
        }

        else if (sEventName == "OnAuthClientSIP") 
        {
            var sMethod = aEventParam[0];
            var sRealm = aEventParam[1];

            var sURI = aEventParam[2];
            var sNonce = aEventParam[3];

            var sQop = aEventParam[4];
            var sOpaque = aEventParam[5];

            var sStatusCode = aEventParam[6];
            var sProcessId = aEventParam[7];
            var sUserInfo = aEventParam[8];

            this.OnAuthClientSIP(sMethod, sRealm, sURI, sNonce, sQop, sOpaque, sStatusCode, sProcessId, sUserInfo);
        }

        else if (sEventName == "OnConnectingToRegister") 
        {
            this.OnConnectingToRegister();
        }

        else if (sEventName == "OnTryingToRegister") 
        {
            this.OnTryingToRegister();
        }

        else if (sEventName == "OnFailToRegister") 
        {
            var nStatusCode = aEventParam[0];
            var sReasonPhrase = aEventParam[1];

            this.OnFailToRegister(nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnSuccessToRegister") 
        {
            this.OnSuccessToRegister();
        }

        else if (sEventName == "OnConnectingToReRegister") 
        {
            this.OnConnectingToReRegister();
        }

        else if (sEventName == "OnTryingToReRegister") 
        {
            this.OnTryingToReRegister();
        }

        else if (sEventName == "OnFailToReRegister") 
        {
            var nStatusCode = aEventParam[0];
            var sReasonPhrase = aEventParam[1];

            this.OnFailToReRegister(nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnSuccessToReRegister") 
        {
            this.OnSuccessToReRegister();
        }

        else if (sEventName == "OnTryingToUnRegister") 
        {
            this.OnTryingToUnRegister();
        }

        else if (sEventName == "OnFailToUnRegister") 
        {
            this.OnFailToUnRegister();
        }

        else if (sEventName == "OnSuccessToUnRegister") {
            OnSuccessToUnRegister();
        }

        else if (sEventName == "OnDialCallStarted") 
        {
            var sCallerName = jsonParse.param0

            var sCallerId = aEventParam[1];
            var sDialNo = aEventParam[2];

            this.OnDialCallStarted(sCallerName, sCallerId, sDialNo);
        }

        else if (sEventName == "OnDialingCall") 
        {
            var nStatusCode = aEventParam[0];
            var sReasonPhrase = aEventParam[1];

            this.OnDialingCall(nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnDialCallFailed") 
        {
            var nStatusCode = aEventParam[0];
            var sReasonPhrase = aEventParam[1];
            var sContact = aEventParam[2];

            this.OnDialCallFailed(nStatusCode, sReasonPhrase, sContact);
        }

        else if (sEventName == "OnDialCallConnected") 
        {
            var sSDP = aEventParam[0];
            var sToRTPIP = aEventParam[1];
            var nToRTPPort = aEventParam[2];

            this.OnDialCallConnected(sSDP, sToRTPIP, nToRTPPort);
        }

        else if (sEventName == "OnAcceptCallConnected") 
        {
            var sToRTPIP = aEventParam[0];
            var nToRTPPort = aEventParam[1];

            this.OnAcceptCallConnected(sToRTPIP, nToRTPPort);
        }

        else if (sEventName == "OnHungupCall") 
        {
            this.OnHungupCall();
        }

        else if (sEventName == "OnIncomingCallStarted") 
        {
            var sSDP = aEventParam[0];
            var sCallId = aEventParam[1];
            var sCallerName = aEventParam[2];

            var sCallerId = aEventParam[3];
            var sDialNo = aEventParam[4];

            var sFromURI = aEventParam[5];
            var sToURI = aEventParam[6];

            this.OnIncomingCallStarted(sSDP, sCallId, sCallerName, sCallerId, sDialNo, sFromURI, sToURI);
        }

        else if (sEventName == "OnIncomingCallEnded") 
        {
            var sCallId = aEventParam[0];

            this.OnIncomingCallEnded(sCallId);
        }

        else if (sEventName == "OnTransferCallFailed") 
        {
            var nStatusCode = aEventParam[0];
            var sReasonPhrase = aEventParam[1];

            this.OnTransferCallFailed(nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnTransferCallAccepted") 
        {
            this.OnTransferCallAccepted();
        }

        else if (sEventName == "OnDigitDTMF") 
        {
            var sDigit = aEventParam[0];

            this.OnDigitDTMF(sDigit)
        }

        else if (sEventName == "OnVoiceMailMsg") 
        {
            var bIsMsgWaiting = aEventParam[0];
            var nNewMsgCount = aEventParam[1];

            var nOldMsgCount = aEventParam[2];
            var nNewUrgentMsgCount = aEventParam[3];

            var nOldUrgentMsgCount = aEventParam[4];
            var sMsgAccount = aEventParam[5];

            this.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
        }

        else if (sEventName == "OnRingToneStarted") 
        {
            var sCallId = aEventParam[0];

            this.OnRingToneStarted(sCallId);
        }

        else if (sEventName == "OnRingToneEnded") 
        {
            var sCallId = aEventParam[0];

            this.OnRingToneEnded(sCallId);
        }

        else if (sEventName == "OnAudioSessionLost") 
        {
            this.OnAudioSessionLost();
        }

        else if (sEventName == "OnSuccessToHold") 
        {
            this.OnSuccessToHold();
        }

        else if (sEventName == "OnTryingToHold") 
        {
            this.OnTryingToHold();
        }

        else if (sEventName == "OnFailToHold") 
        {
            this.OnFailToHold();
        }

        else if (sEventName == "OnSuccessToUnHold") 
        {
            this.OnSuccessToUnHold();
        }

        else if (sEventName == "OnTryingToUnHold") 
        {
            this.OnTryingToUnHold();
        }

        else if (sEventName == "OnFailToUnHold") 
        {
            this.OnFailToUnHold();
        }

        else if (sEventName == "OnChatContactStatus") 
        {
            var sUserName = aEventParam[0];
            var nStatusId = aEventParam[1];

            this.OnChatContactStatus(sUserName, nStatusId);
        }

        else if (sEventName == "OnChatSendMsgTextSuccess") 
        {
            var sUserName = aEventParam[0];
            var sMsgText = aEventParam[1];
            var nUserValue32bit = aEventParam[2];

            this.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit);
        }

        else if (sEventName == "OnChatSendMsgTextFail") 
        {
            var sUserName = aEventParam[0];
            var nStatusCode = aEventParam[1];

            var sReasonPhrase = aEventParam[2];
            var sMsgText = aEventParam[3];

            var nUserValue32bit = aEventParam[4];

            this.OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit);
        }

        else if (sEventName == "OnChatSendMsgTypingSuccess") 
        {
            var sUserName = aEventParam[0];
            var nUserValue32bit = aEventParam[1];

            this.OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit);
        }

        else if (sEventName == "OnChatSendMsgTypingFail") 
        {
            var sUserName = aEventParam[0];
            var nStatusCode = aEventParam[1];

            var sReasonPhrase = aEventParam[2];
            var nUserValue32bit = aEventParam[3];

            this.OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit)
        }

        else if (sEventName == "OnChatRecvMsgText") 
        {
            var sUserName = aEventParam[0];
            var sMsgText = aEventParam[1];

            var bIsChatContact = aEventParam[2];

            this.OnChatRecvMsgText(sUserName, sMsgText, bIsChatContact)
        }

        else if (sEventName == "OnChatRecvMsgTypingStart") 
        {
            var sUserName = aEventParam[0];

            this.OnChatRecvMsgTypingStart(sUserName);
        }

        else if (sEventName == "OnChatRecvMsgTypingStop") 
        {
            var sUserName = aEventParam[0];

            this.OnChatRecvMsgTypingStop(sUserName);
        }

        else if (sEventName == "OnHoldCall") 
        {
            this.OnHoldCall();
        }

        else if (sEventName == "OnUnHoldCall") 
        {
            this.OnUnHoldCall()
        }

        else if (sEventName == "OnAddCallHistory") 
        {
            var bOutboundCallType = aEventParam[0];
            var sCallerName = aEventParam[1];

            var sCallerId = aEventParam[2];
            var sDialNo = aEventParam[3];

            var nStartTime = aEventParam[4];
            var nEndTime = aEventParam[5];

            var nDuration = aEventParam[6];
            var nDayNo = aEventParam[7];
            var nHistoryTypeId = aEventParam[8];

            this.OnAddCallHistory(bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
        }

        else if (sEventName == "OnBusyLampSubscribeSuccess") 
        {
            var sUserName = aEventParam[0];

            this.OnBusyLampSubscribeSuccess(sUserName);
        }

        else if (sEventName == "OnBusyLampSubscribeFailed") 
        {
            var sUserName = aEventParam[0];
            var nStatusCode = aEventParam[1];
            var sReasonPhrase = jsonParse.param2

            this.OnBusyLampSubscribeFailed(sUserName, nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnBusyLampContactStatus") 
        {
            var sUserName = aEventParam[0];
            var nStatusId = aEventParam[1];

            this.OnBusyLampContactStatus(sUserName, nStatusId);
        }

        else if (sEventName == "OnVaxErrorMsg") 
        {
            var sFuncName = aEventParam[0];
            var sErrorMsg = aEventParam[1];

            var nErrorCode = aEventParam[2];

            this.OnVaxErrorMsg(sFuncName, sErrorMsg, nErrorCode);
        }
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////

    this.OnInitialized = function () 
    {
        m_objVaxFuncSIP.OnInitialized();
    }

    this.OnUnInitialized = function () 
    {

    }

    this.OnAuthClientSIP = function (sMethod, sRealm, sURI, sNonce, sQop, sOpaque, sStatusCode, sProcessId, sUserInfo) 
    {
        m_objVaxFuncSIP.ProcessAuthClientSIP(sMethod, sRealm, sURI, sNonce, sQop, sOpaque, sStatusCode, sProcessId, sUserInfo);
    }

    this.OnConnectingToRegister = function () 
    {
        m_objVaxAccount.OnConnectingToRegister();
    }

    this.OnTryingToRegister = function () 
    {
        m_objVaxAccount.OnTryingToRegister();
    }

    this, OnFailToRegister = function (nStatusCode, sReasonPhrase) 
    {
        m_objVaxAccount.OnFailToRegister(nStatusCode, sReasonPhrase);
    }

    this.OnSuccessToRegister = function () 
    {
        m_objVaxAccount.OnSuccessToRegister();
    }

    this.OnConnectingToReRegister = function () 
    {
        m_objVaxAccount.OnConnectingToReRegister();
    }

    this.OnTryingToReRegister = function () 
    {
        m_objVaxAccount.OnTryingToReRegister();
    }

    this.OnFailToReRegister = function (nStatusCode, sReasonPhrase) 
    {
        m_objVaxAccount.OnFailToReRegister(nStatusCode, sReasonPhrase);
    }

    this.OnSuccessToReRegister = function () 
    {
        m_objVaxAccount.OnSuccessToReRegister();
    }

    this.OnTryingToUnRegister = function () 
    {
        m_objVaxAccount.OnTryingToUnRegister();
    }

    this.OnFailToUnRegister = function () 
    {
        m_objVaxAccount.OnFailToUnRegister();
    }

    this.OnSuccessToUnRegister = function () 
    {
        m_objVaxAccount.OnSuccessToUnRegister();
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    this.OnDialCallStarted = function (sCallerName, sCallerId, sDialNo) 
    {
        m_objVaxPhoneOutgoingCall.OnDialCallStarted(sCallerName, sCallerId, sDialNo);
    }

    this.OnDialingCall = function (nStatusCode, sReasonPhrase) 
    {
        m_objVaxPhoneOutgoingCall.OnDialingCall(nStatusCode, sReasonPhrase);
    }

    this.OnDialCallFailed = function (nStatusCode, sReasonPhrase, sContact) 
    {
        m_objVaxPhoneOutgoingCall.OnDialCallFailed(nStatusCode, sReasonPhrase, sContact);
    }

    this.OnDialCallConnected = function (sSDP, sToRTPIP, nToRTPPort) 
    {
        m_objVaxWebRTC.SetOfferRemoteWebRTC(sSDP);
        m_objVaxPhoneOutgoingCall.OnDialCallConnected(sToRTPIP, nToRTPPort);
    }

    this.OnAcceptCallConnected = function (sToRTPIP, nToRTPPort) 
    {
        m_objVaxPhoneIncomingCall.OnAcceptCallConnected(sToRTPIP, nToRTPPort);
    }

    this.OnHungupCall = function () 
    {
        m_objVaxFuncSIP.CloseConnection();
        m_objVaxPhoneOutgoingCall.OnHungupCall();
    }

    this.OnIncomingCallStarted = function (sSDP, sCallId, sCallerName, sCallerId, sDialNo, sFromURI, sToURI) 
    {
        m_objVaxFuncSIP.PostRingingMsg();
        m_objVaxIncomingCall.OnIncomingCallStarted(sSDP, sCallId, sCallerName, sCallerName, sFromURI, sToURI);
    }

    this.OnIncomingCallEnded = function (sCallId)
    {

    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    this.OnTransferCallFailed = function (nStatusCode, sReasonPhrase) 
    {
        m_objVaxPhoneTransfer.OnTransferCallFailed(nStatusCode, sReasonPhrase);
    }

    this.OnTransferCallAccepted = function () 
    {
        m_objVaxPhoneTransfer.OnTransferCallAccepted();
    }

    this.OnDigitDTMF = function (sDigit) 
    {
        m_objVaxPhone.OnDigitDTMF(sDigit);
    }

    this.OnVoiceMailMsg = function (bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount) 
    {
        m_objVaxAccount.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
    }

    this.OnRingToneStarted = function (sCallId) 
    {

    }

    this.OnRingToneEnded = function (sCallId) 
    {

    }

    this.OnAudioSessionLost = function () 
    {

    }

    //////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////

    this.OnSuccessToHold = function () 
    {
    }

    this.OnTryingToHold = function () 
    {
    }

    this.OnFailToHold = function () 
    {
    }

    this.OnSuccessToUnHold = function () 
    {
    }

    this.OnTryingToUnHold = function () 
    {
    }

    this.OnFailToUnHold = function () 
    {
    }

    /////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////

    this.OnChatContactStatus = function (sUserName, nStatusId) 
    {
        m_objVaxChat.OnChatContactStatus(sUserName, nStatusId);
    }

    this.OnChatSendMsgTextSuccess = function (sUserName, sMsgText, nUserValue32bit) 
    {
        m_objVaxChat.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit);
    }

    this.OnChatSendMsgTextFail = function (sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit) 
    {
        m_objVaxChat.OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit);
    }

    this.OnChatSendMsgTypingSuccess = function (sUserName, nUserValue32bit) 
    {
        m_objVaxChat.OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit);
    }

    this.OnChatSendMsgTypingFail = function (sUserName, nStatusCode, sReasonPhrase, nUserValue32bit) 
    {
        m_objVaxChat.OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit);
    }

    this.OnChatRecvMsgText = function (sUserName, sMsgText, bIsChatContact) 
    {
        m_objVaxChat.OnChatRecvMsgText(sUserName, sMsgText);
    }

    this.OnChatRecvMsgTypingStart = function (sUserName) 
    {
        m_objVaxChat.OnChatRecvMsgTypingStart(sUserName);
    }

    this.OnChatRecvMsgTypingStop = function (sUserName) 
    {
        m_objVaxChat.OnChatRecvMsgTypingStop();
    }

    this.OnAddCallHistory = function (bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId) 
    {

    }

    this.OnBusyLampSubscribeSuccess = function (sUserName) 
    {

    }

    this.OnBusyLampSubscribeFailed = function (sUserName, nStatusCode, sReasonPhrase) 
    {

    }

    this.OnBusyLampContactStatus = function (sUserName, nStatusId) 
    {

    }

    this.OnVaxErrorMsg = function (sEventName, sErrorMsg, nErrorCode) 
    {

    }

    this.OnIncomingCallAccepted = function (sSDP, sCallId) 
    {
        m_sAcceptedCallId = sCallId;
        m_objVaxWebRTC.AnswerCreateWebRTC(sSDP);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////

    this.OnAnswerCreatedSuccessWebRTC = function (sLocalSDP) 
    {
        m_objVaxFuncSIP.AcceptCall(sLocalSDP, m_sAcceptedCallId);
    }

    this.OnAnswerCreatedFailedWebRTC = function (error) 
    {
        
    }
}
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////